;Cheapo nastio level editor
;Written by Dabz 2006

Graphics 640,480,16,1

Const GRID_WIDTH = 15
Const GRID_HEIGHT = 15
Local currentTile
Local hitAmount

Dim grid(GRID_WIDTH,GRID_HEIGHT)

tiles = LoadAnimImage("batTiles.png",16,16,0,9)
cursor = LoadImage("curs.bmp")

Repeat
Cls
mx = MouseX()
my = MouseY()

;Draw grid
For loopy = 0 To GRID_HEIGHT-1
	For loopx = 0 To GRID_WIDTH-1
		DrawImage tiles, loopx Shl 4,loopy Shl 4,grid(loopx,loopy)
	Next
Next

;Input stuff
If MouseHit(2)   ;Right-Click changes drawing tile
	currentTile = currentTile+1
	If currentTile > 8 Then currentTile = 0
End If

If MouseDown(1)   ;Left-Click places drawing tile on grid
	grid(mx Shr 4,my Shr 4) = currentTile
End If

;check hitpoints
hitPoints = 0
For loopy = 0 To GRID_HEIGHT-1
	For loopx = 0 To GRID_WIDTH-1
		If grid(loopx,loopy) > 2 Then hitpoints = hitpoints + 1
	Next
Next

;Draw Cursor
DrawImage cursor,mx,my

;info'
Text 260,0,"Current Drawing Tile:"
DrawImage tiles,430,0,currentTile
Text 260,20,"Hitpoints:"+hitpoints

Flip
Until KeyDown(1)

;Save the tilemap to file (as Data) after ESC is pressed
fileout = WriteFile("grid.bb")
WriteLine (fileout,";Level Editor output file")
WriteLine (fileout,".gridData")

For loopy = 0 To GRID_HEIGHT-1
	textOut$ = "Data "
	For loopx = 0 To GRID_WIDTH-1
		textOut$ = textOut$ + grid(loopx,loopy)+","
	Next
	WriteLine (fileout,Left$(textOut$,Len(textOut$)-1))
Next
WriteLine (fileout,"Data "+hitpoints)
CloseFile fileout

End 